import java.util.Scanner;

public class Main {
	
	public static Scanner input;
	

	public static void main(String[] args) {
		
		input = new Scanner (System.in);
		
		while(input.hasNext()){
			String entrada = input.nextLine();
			
			if(entrada.equals("exit")){
				break;
			}
			
			String jogada[] = entrada.split(" ");
			
			int jogadas[]= new int[jogada.length];
			
			for (int i = 0; i < jogada.length; i++) {
				jogadas[i] = Integer.parseInt(jogada[i]);
			}
			ganhadores(jogadas, jogadas.length, 0);
		}
	}
	static void ganhadores(int[] jogadas, int jogadores, int rodadas){
		
		boolean perdeu[] = new boolean[jogadores];
		boolean ganhou[] = new boolean[jogadores];
		for (int i = 0; i < ganhou.length; i++) {
			ganhou[i] = false;
			perdeu[i] = false;
		}
		
		for (int i = 0; i < jogadores; i++) {
			for (int j = i + 1; j < jogadores; j++) {
				if(jogadas[i] != jogadas[j]){
					if (ganhaDe(jogadas[i], jogadas[j])){
						ganhou[i] = true;
						perdeu[j] = true;
					} else {
						ganhou[j] = true;
						perdeu[i] = true;
					}
				}
			}
		}
		int qtddGanhadores = 0;
		int vencedor = -1;
		for (int i = 0; i < ganhou.length; i++) {
			if(ganhou[i] == true && perdeu[i] == false){
				qtddGanhadores++;
				vencedor = i;
			}else if(ganhou[i] == false && perdeu[i] == true){
				jogadas[i] = 0;
			}
		}
		
		if(qtddGanhadores == 1){
			vencedor++;
			System.out.println("O jogador "+ vencedor +" venceu!");
		}else if(rodadas == jogadas.length){
			System.out.println("Ninguem ganhou!");
		}else{
			jogadas = mudaJogada(jogadas);
			ganhadores(jogadas, jogadores, ++rodadas);
		}
	}
	
	static int[] mudaJogada(int[] jogadas){
		
		for (int i = 0; i < jogadas.length; i++) {
			if(jogadas[i] > 0){
				jogadas[i] += i;
			}
			if(jogadas[i] > 5){
				jogadas[i] = jogadas[i] % 5;
			}
		}
		for (int i = 0; i < jogadas.length; i++) {
			if(i == jogadas.length - 1)System.out.println(jogadas[i]);
			else System.out.print(jogadas[i]+" ");
		}
		
		return jogadas;
	}
	
	static boolean ganhaDe (int jogador1, int jogador2){
		
		if(jogador2 == 0)return true;

		switch (jogador1) {
		case 1:
			if(jogador2 == 5 || jogador2 == 3)return true;
			return false;
		case 2:
			if(jogador2 == 1 || jogador2 == 4)return true;
			return false;
		case 3:
			if(jogador2 == 2 || jogador2 == 5)return true;
			return false;
		case 4:
			if(jogador2 == 3 || jogador2 == 1)return true;
			return false;
		case 5:
			if(jogador2 == 4 || jogador2 == 2)return true;
			return false;
		default:
			return false;
		}
	}
}
